searchData={"items":[{"type":"module","title":"VCNL4040","doc":"GenServer-based driver module for ambient light and proximity sensor combo.\n\nSee datasheet: https://www.vishay.com/docs/84274/vcnl4040.pdf\nImplementation notes: https://www.vishay.com/docs/84307/designingvcnl4040.pdf","ref":"VCNL4040.html"},{"type":"function","title":"VCNL4040.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"VCNL4040.html#child_spec/1"},{"type":"function","title":"VCNL4040.close/0","doc":"Tell the driver to shut down open resources and exit.\n\nThis assumes you registered your GenServer with `name: VCNL4040`.\n\nReturns :ok","ref":"VCNL4040.html#close/0"},{"type":"function","title":"VCNL4040.close/1","doc":"Tell the driver to shut down open resources and exit.\n\nReturns :ok","ref":"VCNL4040.html#close/1"},{"type":"function","title":"VCNL4040.get_ambient_light/1","doc":"Returns the current reading from the ambient light sensor\n\nThis assumes you registered your GenServer with `name: VCNL4040`.\n\nThe `type` argument can be:\n\n* `:filtered` - converted to lux and the median of the samples in the buffer, avoiding outliers.\n* `:lux` - latest read, converted to lux.\n* `:raw` - latest read, straight from the sensor. If you have some weird use for it.\n\nReturns `:timeout` or `:noproc` if the GenServer times out or isn't running.","ref":"VCNL4040.html#get_ambient_light/1"},{"type":"function","title":"VCNL4040.get_ambient_light/2","doc":"Returns the current filtered reading from the ambient light sensor.\n\nThe `type` argument can be:\n\n* `:filtered` - converted to lux and the median of the samples in the buffer, avoiding outliers.\n* `:lux` - latest read, converted to lux.\n* `:raw` - latest read, straight from the sensor. If you have some weird use for it.\n\nReturns `:timeout` or `:noproc` if the GenServer times out or isn't running.","ref":"VCNL4040.html#get_ambient_light/2"},{"type":"function","title":"VCNL4040.get_device_config/0","doc":"Returns the current `VCNL4040.DeviceConfig` struct.\n\nThis assumes you registered your GenServer with `name: VCNL4040`.\n\nReturns `:timeout` or `:noproc` if the GenServer times out or isn't running.","ref":"VCNL4040.html#get_device_config/0"},{"type":"function","title":"VCNL4040.get_device_config/1","doc":"Returns the current `VCNL4040.DeviceConfig` struct.\n\nThis assumes you registered your GenServer with `name: VCNL4040`.\n\nReturns `:timeout` or `:noproc` if the GenServer times out or isn't running.","ref":"VCNL4040.html#get_device_config/1"},{"type":"function","title":"VCNL4040.get_proximity/1","doc":"Returns the current reading from the ambient light sensor.\n\nThis assumes you registered your GenServer with `name: VCNL4040`.\n\nThe `type` argumnet can be:\n\n* `:filtered` - converted to lux and the median of the samples in the buffer, avoiding outliers.\n* `:raw` - latest read, straight from the sensor. If you have some weird use for it.\n\nReturns `:timeout` or `:noproc` if the GenServer times out or isn't running.","ref":"VCNL4040.html#get_proximity/1"},{"type":"function","title":"VCNL4040.get_proximity/2","doc":"Returns the current reading from the ambient light sensor.\n\nThe `type` argumnet can be:\n\n* `:filtered` - converted to lux and the median of the samples in the buffer, avoiding outliers.\n* `:raw` - latest read, straight from the sensor. If you have some weird use for it.\n\nReturns `:timeout` or `:noproc` if the GenServer times out or isn't running.","ref":"VCNL4040.html#get_proximity/2"},{"type":"macro","title":"VCNL4040.is_server/1","doc":"","ref":"VCNL4040.html#is_server/1"},{"type":"function","title":"VCNL4040.sensor_present?/0","doc":"Returns true if the combo prox/light sensor is present and matches the expected device ID.\n\nThis assumes you registered your GenServer with `name: VCNL4040`.\n\nReturns a boolean indicating whether the sensor is present.","ref":"VCNL4040.html#sensor_present?/0"},{"type":"function","title":"VCNL4040.sensor_present?/1","doc":"Returns true if the combo prox/light sensor is present and matches the expected device ID.","ref":"VCNL4040.html#sensor_present?/1"},{"type":"function","title":"VCNL4040.set_device_config/1","doc":"Sets a new `VCNL4040.DeviceConfig` and applies it to the hardware.\n\nThis assumes you registered your GenServer with `name: VCNL4040`.\n\nReturns `:timeout` or `:noproc` if the GenServer times out or isn't running.","ref":"VCNL4040.html#set_device_config/1"},{"type":"function","title":"VCNL4040.set_device_config/2","doc":"Sets a new `VCNL4040.DeviceConfig` and applies it to the hardware.\n\nReturns `:timeout` or `:noproc` if the GenServer times out or isn't running.","ref":"VCNL4040.html#set_device_config/2"},{"type":"function","title":"VCNL4040.start_link/1","doc":"Start the ambient light/proximity sensor driver\n\nOptions:\n* `:name` - regular GenServer registration name, makes public API functions more convenient if only using one sensor.\n* `:i2c_bus` - defaults to `\"i2c-0\"`\n* `:notify_pid` - PID to notify on every sample pulled. Default: nil\n* `:device_config` - defaults to turning on ambient light sensor and proximity sensor for polling. Pass your own `DeviceConfig` to modify.\n* `:interrupt_pin` - required to enable interrupt-driven sensing, requires the hardware connection for GPIO INT pin set up\n* `:poll_interval` - millisecond interval for polling sensors. Set to `nil` to disable. Default: 1000 (1 second)\n* `:buffer_samples` - size of the internal circular buffer for filtered readings. Default: 9\n* `:als_enable?` - enable the Ambient Light Sensor immediately. Default: true (not hardware default)\n* `:als_integration_time` - integration time for Ambient Light Sensor. Default: 80\n* `:ps_enable?` - enable the Proximity Sensor immediately. Default: true (not hardware default)\n* `:ps_integration_time` - integration time for Proximity Sensor. Default: :t1 (weirdo time units, see data sheet?)\n* `:log_samples?` - always print sample collection to log. Default: false\n* `:als_interrupt_tolerance` - enables automatic following of light level using interrupts. Default: nil","ref":"VCNL4040.html#start_link/1"},{"type":"module","title":"VCNL4040.DeviceConfig","doc":"Module for managing device configuration.\n\nTypically applied during `VCNL4040.start_link/1` or with `VCNL4040.set_device_config/2`.\n\nThere are some utility functions but much of the API-surface is based on\nthe naming conventions in [the datasheet](https://www.vishay.com/docs/84274/vcnl4040.pdf).","ref":"VCNL4040.DeviceConfig.html"},{"type":"module","title":"Examples - VCNL4040.DeviceConfig","doc":"```\niex> import VCNL4040.DeviceConfig\niex> new() |> update!(:als_conf, als_it: 320)\n%VCNL4040.DeviceConfig{config: %{\n    als_conf: %{\n      als_it: 320,\n      als_int_en: false,\n      als_pers: 1,\n      als_sd: true\n    }\n  },\n  registers: %{\n    als_conf: <<129>>\n  }\n}\n```","ref":"VCNL4040.DeviceConfig.html#module-examples"},{"type":"function","title":"VCNL4040.DeviceConfig.als_conf/2","doc":"Ambient Light Sensor configuration.\n\nReturns a tuple tagged by field with binary and config map.","ref":"VCNL4040.DeviceConfig.html#als_conf/2"},{"type":"function","title":"VCNL4040.DeviceConfig.als_for_polling/2","doc":"Convenience for starting Ambient Light Sensor functionality.\n\nNo interrupts configured.","ref":"VCNL4040.DeviceConfig.html#als_for_polling/2"},{"type":"function","title":"VCNL4040.DeviceConfig.als_thdh/2","doc":"Sets high threshold for Ambient Light Sensor interrupt.\n\nReturns a tuple tagged by field with binary and value.","ref":"VCNL4040.DeviceConfig.html#als_thdh/2"},{"type":"function","title":"VCNL4040.DeviceConfig.als_thdl/2","doc":"Sets low threshold for Ambient Light Sensor interrupt.\n\nReturns a tuple tagged by field with binary and value.","ref":"VCNL4040.DeviceConfig.html#als_thdl/2"},{"type":"function","title":"VCNL4040.DeviceConfig.als_threshhold_high/1","doc":"Sets high threshold for Ambient Light Sensor interrupt.\n\nAlias for `als_thdh` with better name.\n\nReturns a tuple tagged by field with binary and value.","ref":"VCNL4040.DeviceConfig.html#als_threshhold_high/1"},{"type":"function","title":"VCNL4040.DeviceConfig.als_threshhold_low/1","doc":"Sets low threshold for Ambient Light Sensor interrupt.\n\nAlias for `als_thdl` with better name.\n\nReturns a tuple tagged by field with binary and value.","ref":"VCNL4040.DeviceConfig.html#als_threshhold_low/1"},{"type":"function","title":"VCNL4040.DeviceConfig.als_with_interrupts/4","doc":"Convenience for starting Ambient Light Sensor functionality.\n\nConfigures interrupts with thresholds.","ref":"VCNL4040.DeviceConfig.html#als_with_interrupts/4"},{"type":"function","title":"VCNL4040.DeviceConfig.get_all_registers_for_i2c/1","doc":"Get all writable registers, ready for I2C writing.","ref":"VCNL4040.DeviceConfig.html#get_all_registers_for_i2c/1"},{"type":"function","title":"VCNL4040.DeviceConfig.get_register_for_i2c/2","doc":"Output a binary appropriate for writing to I2C.\n\nLabel is a writable register as an atom, example: `:als_conf` or `:ps_conf2`\n\nReturn value includes 8-bit address prefixed to the payload.","ref":"VCNL4040.DeviceConfig.html#get_register_for_i2c/2"},{"type":"macro","title":"VCNL4040.DeviceConfig.is_threshold/1","doc":"","ref":"VCNL4040.DeviceConfig.html#is_threshold/1"},{"type":"function","title":"VCNL4040.DeviceConfig.merge_configs/2","doc":"Merges the second configuration onto the first.\n\nThis will override configuration at a sub-register or register level.\nIt can be used to combine your settings for als_conf and ps_conf1 but\nnot two different als_conf registers. The second one will win.","ref":"VCNL4040.DeviceConfig.html#merge_configs/2"},{"type":"function","title":"VCNL4040.DeviceConfig.new/0","doc":"Create a new blank DeviceConfig.\n\nA blank configuration will produce default values when used.\n\nThe defaults for this device include that both the Ambient Light Sensor\nand the Proximity Sensor are \"shut down\" aka turned off.","ref":"VCNL4040.DeviceConfig.html#new/0"},{"type":"function","title":"VCNL4040.DeviceConfig.ps_canc/2","doc":"","ref":"VCNL4040.DeviceConfig.html#ps_canc/2"},{"type":"function","title":"VCNL4040.DeviceConfig.ps_cancellation/1","doc":"","ref":"VCNL4040.DeviceConfig.html#ps_cancellation/1"},{"type":"function","title":"VCNL4040.DeviceConfig.ps_conf1/2","doc":"Proximity sensor configuration, part 1.\n\nDuty cycle is 1/40, 1/80, 1/160, 1/320.\n\nReturns a tuple tagged by field with binary and config map.","ref":"VCNL4040.DeviceConfig.html#ps_conf1/2"},{"type":"function","title":"VCNL4040.DeviceConfig.ps_conf2/2","doc":"Proximity sensor configuration, part 2\n\nReturns a tuple tagged by field with binary and config map.","ref":"VCNL4040.DeviceConfig.html#ps_conf2/2"},{"type":"function","title":"VCNL4040.DeviceConfig.ps_conf3/2","doc":"Proximity sensor configuration, part 3\n\nReturns a tuple tagged by field with binary and config map.","ref":"VCNL4040.DeviceConfig.html#ps_conf3/2"},{"type":"function","title":"VCNL4040.DeviceConfig.ps_for_polling/3","doc":"Convenience for starting Proximity Sensor without interrupts.","ref":"VCNL4040.DeviceConfig.html#ps_for_polling/3"},{"type":"function","title":"VCNL4040.DeviceConfig.ps_ms/2","doc":"Proximity sensor - More Settings?\n\nps_ms means detection logic mode, it will disable ALS interrupts.\n\nReturns a tuple tagged by field with binary and config map.","ref":"VCNL4040.DeviceConfig.html#ps_ms/2"},{"type":"function","title":"VCNL4040.DeviceConfig.ps_thdh/2","doc":"","ref":"VCNL4040.DeviceConfig.html#ps_thdh/2"},{"type":"function","title":"VCNL4040.DeviceConfig.ps_thdl/2","doc":"","ref":"VCNL4040.DeviceConfig.html#ps_thdl/2"},{"type":"function","title":"VCNL4040.DeviceConfig.ps_threshold_high/1","doc":"","ref":"VCNL4040.DeviceConfig.html#ps_threshold_high/1"},{"type":"function","title":"VCNL4040.DeviceConfig.ps_threshold_low/1","doc":"","ref":"VCNL4040.DeviceConfig.html#ps_threshold_low/1"},{"type":"function","title":"VCNL4040.DeviceConfig.ps_with_interrupts/6","doc":"Convenience for starting Proximity Sensor with interrupts.","ref":"VCNL4040.DeviceConfig.html#ps_with_interrupts/6"},{"type":"function","title":"VCNL4040.DeviceConfig.reserved/0","doc":"","ref":"VCNL4040.DeviceConfig.html#reserved/0"},{"type":"function","title":"VCNL4040.DeviceConfig.set!/2","doc":"This will set a DeviceConfig register based on the output of a register function.\n\nReturns the updated DeviceConfig struct.","ref":"VCNL4040.DeviceConfig.html#set!/2"},{"type":"function","title":"Example - VCNL4040.DeviceConfig.set!/2","doc":"```\niex> import VCNL4040.DeviceConfig\niex> new() |> set!(als_conf(als_it: 320))\n%VCNL4040.DeviceConfig{config: %{\n    als_conf: %{\n      als_it: 320,\n      als_int_en: false,\n      als_pers: 1,\n      als_sd: true\n    }\n  },\n  registers: %{\n    als_conf: <<129>>\n  }\n}\n```","ref":"VCNL4040.DeviceConfig.html#set!/2-example"},{"type":"function","title":"VCNL4040.DeviceConfig.update!/3","doc":"This will granularly update a DeviceConfig.\n\nReturns the updated DeviceConfig struct.","ref":"VCNL4040.DeviceConfig.html#update!/3"},{"type":"function","title":"Example - VCNL4040.DeviceConfig.update!/3","doc":"```\niex> import VCNL4040.DeviceConfig\niex> new() |> update!(:als_conf, als_it: 320) |> update!(:als_conf, als_pers: 2)\n%VCNL4040.DeviceConfig{config: %{\n    als_conf: %{\n      als_it: 320,\n      als_int_en: false,\n      als_pers: 1,\n      als_sd: true\n    }\n  },\n  registers: %{\n    als_conf: <<129>>\n  }\n}\n```","ref":"VCNL4040.DeviceConfig.html#update!/3-example"},{"type":"exception","title":"VCNL4040.Hardware.HardwareError","doc":"","ref":"VCNL4040.Hardware.HardwareError.html"},{"type":"extras","title":"VCNL4040","doc":"# VCNL4040\n\nThis is a Circuits-based Elixir driver for the VCNL4040. The VCNL4040 is an ambient light and proximity sensor. It uses I2C and GPIO for communication and has a pretty cool set of features.\n\nFor details on the hardware consult [the datasheet](https://www.vishay.com/docs/84274/vcnl4040.pdf). There is additional useful detail about the sensor in [the\n  implementation notes](https://www.vishay.com/docs/84307/designingvcnl4040.pdf).\n\nI would not consider the API completely stable yet but it is being tested for real world use.","ref":"readme.html"},{"type":"extras","title":"Installation - VCNL4040","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `vcnl4040` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:vcnl4040, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Getting started - VCNL4040","doc":"If you have I2C hooked up on your device, typically under Nerves:\n\n```\niex> Circuits.I2C.detect_devices() # Use to find the right one, example: \"i2c-1\"\n# .. lots of output, looks for a single device on a single bus, typically\niex> VCNL4040.start_link(i2c_bus: \"i2c-1\", name: VCNL4040, log_samples?: true)\n{:ok, _pid}\niex> VCNL4040.sensor_present?()\ntrue\niex> RingLogger.attach\n# You should start seeing the logged samples from the default setup\n# because of log_samples?: true\n```\n\nWith `log_samples?: true` you should get sample output in your logs every second by default.\n\nSee `VCNL4040.start_link/1` for more detailed documentation on start options.\n\nSee `VCNL4040.DeviceConfig` for more detailed configuration of the hardware.","ref":"readme.html#getting-started"},{"type":"extras","title":"Dynamic interrupt threshold - VCNL4040","doc":"This tries to offload all the work to the device using the built-in interrupt\nfeatures. It requires the interrupt pin to be hooked up.\n\nWhen light changes beyond a certain tolerance it will trigger a sample that\nand then it will adapt the thresholds. This has been reliable for me so far in\ntesting but consider it somewhat experimental.\n\nExampe:\n\n```elixir\n      # This enables interrupts, sets some bogus thresholds and sets 160ms\n      # integration time, plenty of options if you read DeviceConfig\n      device_config = VCNL4040.DeviceConfig.als_with_interrupts(1000, 1600, 160)\n      {:ok, pid} =\n        VCNL4040.start_link(\n          i2c_bus: \"i2c-1\",\n          notify_pid: self(),\n          # Check your pin :)\n          interrupt_pin: 6,\n          #log_samples?: true,\n          # Turn off polling entirely, because that's cool\n          poll_interval: nil,\n          device_config: device_config,\n          als_integration_time: 160,\n          # for light in a range between 0-65335 or so\n          als_interrupt_tolerance: 500,\n          name: VCNL4040\n        )\n\n```","ref":"readme.html#dynamic-interrupt-threshold"},{"type":"extras","title":"Simulated device - VCNL4040","doc":"There is a simulated device for the VCNL4040 in [circuits_sim](https://github.com/elixir-circuits/circuits_sim) at some stage of completion. At the time of writing it does not have GPIO interrupt support.\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#simulated-device"}],"content_type":"text/markdown"}